﻿function BookViewer(params)
{
   this.updated_value_count = 0;
	this.updated_average_rating = 0;

	this._ui_img = params.ui_img;
   
   this._ui_container_2 = params.ui_container_2;
	
	this._getBookViewerWindowMode = params.getBookViewerWindowMode;
	this._setBookViewerWindowMode = params.setBookViewerWindowMode;
	this._refreshBookViewerWindow = params.refreshBookViewerWindow;
	
   this.initPagePortionCount(params.initializationPagePortionCount);
   
   this.pageViewer = new PageViewer(params.ui_container, params.ui_img, params.ui_scale, params.initialization_scale_1_value);
   this.pageViewer_2 = new PageViewer(params.ui_container_2, params.ui_img_2, params.ui_scale_2, params.initialization_scale_2_value);
   
   this._pageCount = parseInt(params.pageCount, 10);
   
   this.isUserCommandExecuting = false;
   this._url_add_bookmark = [];
   this._url_del_bookmark = [];
   
   this._currentVisitController = params.initializationVisitController;
   
	this._visitedPageStack = params.initializationVisitedPageStack;
	
   this._canNotDownloadMessage = [];
   
   var bookViewer = this;
   var ui_bookViewer_state = $("#ctrl_bookViewer_state");
   this._onUserCommandStart = function()
   {
      bookViewer.isUserCommandExecuting = true;
      
      ui_bookViewer_state.html("loading...");
      $("#ctrl_userCard_browserWindow").css("cursor", "progress");
   };
   this._onUserCommandComplete = function()
   {
      bookViewer.isUserCommandExecuting = false;
      
      ui_bookViewer_state.html("");
      $("#ctrl_userCard_browserWindow").css("cursor", "default");
   };
   
   this.outlineViewer = new OutlineViewer(bookViewer, params.ui_outlines, params.initializationOutlinesPanelVisibilityState);
   var outlineViewer = this.outlineViewer;
   params.ui_outlines_toggle.on("click", function() { outlineViewer.toggleOutlinesPanelState(); });
	
   this._ui_maximized_mode_button = params.ui_maximized_mode_button;
   this._ui_maximized_mode_button.on("click", function() { bookViewer.touchMaximizedModeButton(); });

	this.initMaximizedModeButton();
}

BookViewer.prototype.getCurrentVisitController = function ()
{
   return this._currentVisitController;
}

BookViewer.prototype.getVisitedPageStack = function ()
{
	return this._visitedPageStack;
}

BookViewer.prototype.updatePageWindowSizes = function ()
{
   var viewer_left_panel_width = $("#photo_container_left").css("display") == "block" ? $("#photo_container_left").width() : 0;
   var viewer_right_panel_width = ($("#book_viewer_control_panel_main").width() - viewer_left_panel_width) / this.pagePortionCount;
   $("#photo_container_right_outer").width(viewer_right_panel_width);
   $("#photo_container_right_outer_2").width(viewer_right_panel_width);
   
   var viewer_left_panel_height = (document.body.clientHeight * 0.95 - $("#book_viewer_control_panel_main").height() - $("div.ui-dialog-titlebar").height()) - 45;
   var viewer_right_panel_height = viewer_left_panel_height - $("#book_viewer_control_panel_page").height();
   var viewer_right_panel_2_height = viewer_left_panel_height - $("#book_viewer_control_panel_page_2").height();
   $("#photo_container_left").height(viewer_left_panel_height);
   $("#photo_container_right_outer").height(viewer_right_panel_height);
   $("#photo_container_right_outer_2").height(viewer_right_panel_2_height);
}

BookViewer.prototype.touchMaximizedModeButton = function ()
{
   this.fWantSaveBookViewerState = true;
   
	if (this._getBookViewerWindowMode() == "maximized")
      this._setBookViewerWindowMode("normal");
	else
      this._setBookViewerWindowMode("maximized");
	
   var bookViewer = this;
   var refreshBookViewerWindow = function() { bookViewer._refreshBookViewerWindow(); };
   setTimeout(refreshBookViewerWindow, 0);
}

BookViewer.prototype.initMaximizedModeButton = function ()
{
	if (this._getBookViewerWindowMode() == "frozen-maximized")
	{
		this._ui_maximized_mode_button
			.css("display", "none");
	}
	else if (this._getBookViewerWindowMode() == "maximized")
	{
		this._ui_maximized_mode_button
			.attr("src", HTTP_PATH + "/images/minimize.png")
			.attr("title", "Выйти из полноэкранного режима");
	}
	else
	{
		this._ui_maximized_mode_button
			.attr("src", HTTP_PATH + "/images/maximize.png")
			.attr("title", "На весь экран");
	}
}

BookViewer.prototype.getCurrentPage = function ()
{
   return this._currentPage;
}

BookViewer.prototype.showCurrentPage = function (scrollingPosition)
{
	if (this.isUserCommandExecuting) return;
   
   var bookViewer = this;
   var currentPage = this._currentPage;
   var onUserCommandComplete = this._onUserCommandComplete;
   
   var ui_bookViewer_pageNumber = $("#ctrl_bookViewer_pageNumber");
   
   var showPageImage_2 = function () {};
   
   var onUpdatePageControlPanelComplete =
      function()
      {
         ui_bookViewer_pageNumber.val(currentPage);
			
         // высота левой и правой панелей зависят от высоты панели управления,
         // которая становятся известна после её загрузки
         setTimeout(bookViewer.updatePageWindowSizes, 0);
         
         onUserCommandComplete();
      };
   
   var photo_container_right_outer = $("#photo_container_right_outer");
   
   var updatePageControlPanel = 
      function (pageAtPortion)
      {
         return function (pageContext)
            {
               var scrollTop = function() { photo_container_right_outer.scrollTop(0); };
               var scrollBottom = function() { photo_container_right_outer.scrollTop(photo_container_right_outer.get(0).scrollHeight); };
               switch (scrollingPosition)
               {
                 case "scroll-top":
                   scrollTop();
                   break;
                 case "scroll-bottom":
                   scrollBottom();
                   break;
                 case "no-scroll":
                   break;
                 default:
                   scrollTop();
               }
               
               bookViewer.updatePageControlPanel(pageContext, pageAtPortion);
               
               bookViewer.showLinks(pageContext, pageAtPortion);
               
               setTimeout(onUpdatePageControlPanelComplete, 0);
         
               if (pageAtPortion == 0) showPageImage_2();
            };
      };
   
   this._onUserCommandStart();
   
   this._currentVisitController.visitPage(currentPage);
	
   if (this.pagePortionCount > 1)
   {
      if (currentPage + 1 <= this._pageCount)
      {
         showPageImage_2 = function()
         {
            bookViewer.setSecondPageBlankMode(false);
            bookViewer.pageViewer_2.showPageImage(currentPage + 1, updatePageControlPanel(1));
         }
      }
      else
      {
         showPageImage_2 = function()
         {
            bookViewer.setSecondPageBlankMode(true);
         }
      }
   }
   
   this.pageViewer.showPageImage(currentPage, updatePageControlPanel(0));
}

BookViewer.prototype.setSecondPageBlankMode = function (isBlankMode)
{
   var elements = 
      [
         this._ui_container_2,
         $("#ctrl_left_big_2"),
         $("#ctrl_right_big_2"),
         $("#book_viewer_control_panel_page_2")];
         
   for (i in elements)
      elements[i].css("display", isBlankMode ? "none" : "block");
}

BookViewer.prototype.showLinks = function (pageContext, pageAtPortion)
{
   var ui_ctrl_hyperlinks = (pageAtPortion == 0 ? $("#ctrl_hyperlinks") : $("#ctrl_hyperlinks_2"));
   
	var clearHyperlinks =
		function ()
		{
			ui_ctrl_hyperlinks.html("");
		};
	
	clearHyperlinks();
	
	if (pageContext.links.length == 0)
		return;
	
	var bookViewer = this;
	
	var ui_link_lst = [];
	var link_lst = [];
	for (var n in pageContext.links[0])
	{
		var link = pageContext.links[0][n];
		
		var ui_link = $("<div/>");
		
		var show_frame_maker = 
			function (ui_link)
			{
				return function () {
						ui_link.css("border", "3px solid blue");
					}
			};
		var show_frame = show_frame_maker(ui_link);
		
		var hide_frame_maker = 
			function (ui_link)
			{
				return function () {
						ui_link.css("border", "none");
					}
			};
		var hide_frame = hide_frame_maker(ui_link);
		
		var open_url_maker = 
			function (url)
			{
				return function () {
						window.open(url);
					}
			};
			
		var open_page_maker = 
			function (page)
			{
				return function () {
						clearHyperlinks();
		
						bookViewer.openPageLink(page);
					}
			};
		
		var open_link =
			link.type == "0"
			?
			open_page_maker(link.par1)
			:
			open_url_maker(link.par1);
		
		ui_link
			.css("position", "absolute")
			.css("cursor", "pointer")
			.css("border-radius", "10px")
			.click(open_link)
			.on("mouseover", show_frame)
			.on("mouseout", hide_frame)
			.css("z-index", "3")
			.attr("title", link.type == "0" ? "Перейти к странице " + link.par1 : link.par1)
			.appendTo(ui_ctrl_hyperlinks);
			
		ui_link_lst[ui_link_lst.length] = ui_link;
		link_lst[link_lst.length] = link;
	}
	
	var pageViewer = (pageAtPortion == 0 ? this.pageViewer : this.pageViewer_2);
   pageViewer.setLinks(ui_link_lst, link_lst)
   pageViewer.scaleLinks();
}

BookViewer.prototype.openPageLink = function (textPageNumber)
{
	this.showPage(textPageNumber);
}

BookViewer.prototype.openPreviousVisitedPage = function ()
{
	var bookViewer = this;
	var previousVisitedPage = this._visitedPageStack.pop();
	
	setTimeout(
		function () { bookViewer._showPage(previousVisitedPage, "scroll-top", true); },
		0);
}

BookViewer.prototype.updatePageControlPanel = function (pageContext, pageAtPortion)
{
   if (pageContext.url_add_bookmark_error != null)
   {
      alert(pageContext.url_add_bookmark_error);
      return;
   }
   
   this._url_add_bookmark[pageAtPortion] = pageContext.url_add_bookmark;
   this._url_del_bookmark[pageAtPortion] = pageContext.url_del_bookmark;
   
   this.url_set_rating = pageContext.url_set_rating;
   
   this.updated_value_count = parseInt(pageContext.ratingValueCount, 10);
   if (this.updated_value_count > 0)
      this.updated_average_rating = parseInt(pageContext.sumRating, 10) / this.updated_value_count;
   
   this.updated_digital_give_out_count = parseInt(pageContext.digitalGiveOutCount, 10);
   this.updated_give_out_count = parseInt(pageContext.giveOutCount, 10);
   
   var msg_title_rest = "";
   var msg_title_first = "Первая страница ";
   var msg_title_previous = "Предыдущая страница ";
   var msg_title_next = "Следующая страница ";
   var msg_title_last = "Последняя страница ";
   if ((pageContext.accessCode == "1") && (pageContext.unlimited != "true"))
   {
      this._currentVisitController.activate(pageContext.maxCount);
      msg_title_rest = "(для просмотра доступно ещё " + this._currentVisitController.rest() + " страниц)"
   }
   msg_title_first += msg_title_rest;
   msg_title_previous += msg_title_rest;
   msg_title_next += msg_title_rest;
   msg_title_last += msg_title_rest;
   $("#ctrl_firstPage").attr("title", msg_title_first);
   $("#ctrl_previousPage").attr("title", msg_title_previous);
   $("#ctrl_nextPage").attr("title", msg_title_next);
   $("#ctrl_lastPage").attr("title", msg_title_last);

   var ctrl_left_big = pageAtPortion == 0 ? $("#ctrl_left_big") : $("#ctrl_left_big_2");
   var ctrl_left_big_img = pageAtPortion == 0 ? $("#ctrl_left_big_img") : $("#ctrl_left_big_img_2");
   var ctrl_right_big = pageAtPortion == 0 ? $("#ctrl_right_big") : $("#ctrl_right_big_2");
   var ctrl_right_big_img = pageAtPortion == 0 ? $("#ctrl_right_big_img") : $("#ctrl_right_big_img_2");
   
   var opacityNone = 0;
   var opacityHalf = 0.1;
   var opacityFull = 0.5;
   var setLeftBigOpacity = function (value)
      {
         ctrl_left_big_img.css("opacity", value);
      };
   var setRightBigOpacity = function (value)
      {
         ctrl_right_big_img.css("opacity", value);
      };
   var bookViewer = this;
   setLeftBigOpacity(opacityNone);
   setRightBigOpacity(opacityNone);
   $(document).off("keydown");
   ctrl_left_big_img.css("cursor", "default");
   ctrl_left_big
      .off("click")
      .off("mouseover")
      .off("mouseout");
   if (this.havePrevPagePortion())
   {
      ctrl_left_big_img.css("cursor", "pointer");
      ctrl_left_big
         .on(
            "click",
            function () { bookViewer.showPrevPagePortion(); }
            )
         .on(
            "mouseover",
            function () { setLeftBigOpacity(opacityFull); }
            )
         .on(
            "mouseout",
            function () { setLeftBigOpacity(opacityHalf); }
            );
      
      $(document)
         .on(
            "keydown",
            function(event)
            {
               if (event.which == 33) // PgUp
               {
                  bookViewer.showPrevPagePortion();
               }
               if (event.which == 37) // Left
               {
                  bookViewer.showPrevPagePortion();
               }
            });
   }
   ctrl_right_big_img.css("cursor", "default");
   ctrl_right_big
		.off("click")
		.off("mouseover")
		.off("mouseout");
   if (this.haveNextPagePortion())
   {
      ctrl_right_big_img.css("cursor", "pointer");
      ctrl_right_big
			.on(
				"click",
				function () { bookViewer.showNextPagePortion(); }
				)
			.on(
				"mouseover",
				function () { setRightBigOpacity(opacityFull); }
				)
			.on(
				"mouseout",
				function () { setRightBigOpacity(opacityHalf); }
				);
      
      $(document)
         .on(
            "keydown",
               function(event)
               {
                  if (event.which == 34) // PgDn
                  {
                     bookViewer.showNextPagePortion();
                  }
                  if (event.which == 39) // Right
                  {
                     bookViewer.showNextPagePortion();
                  }
               });
   }
	
	this._ui_img.off("wheel");
	this._ui_img.on("wheel",
		function (e)
		{
         if (bookViewer.pagePortionCount > webIrbisSettings.wheelPageChangerSetting) return;
         
			if (e.originalEvent.deltaY > 0)
			{
				if ($("#photo_container_right_outer").scrollTop() + $("#photo_container_right_outer").height() >= $("#photo_container_right_outer").get(0).scrollHeight)
					if (bookViewer.haveNextPagePortion())
						bookViewer.showNextPagePortion();
			}
			else
			{
				if ($("#photo_container_right_outer").scrollTop() == 0)
					if (bookViewer.havePrevPagePortion())
						bookViewer.showPrevPagePortion("scroll-bottom");
			}
		});
	
   var setBackOpacity = function (value)
      {
         $("#ctrl_left_back_img").css("opacity", value);
      };
	setBackOpacity(opacityHalf);
	if (this._visitedPageStack.length == 0)
	{
		$("#ctrl_left_back")
			.css("display", "none");
			
		$("#ctrl_back")
			.css("display", "none");
	}
	else
	{
		var title = "Обратный переход к странице " + this._visitedPageStack[this._visitedPageStack.length - 1];
		
		$("#ctrl_left_back_img").css("cursor", "pointer");
		$("#ctrl_left_back")
			.css("display", "block")
			.attr("title", title)
			.off("click")
			.on(
				"click",
				function () { bookViewer.openPreviousVisitedPage(); }
				)
			.on(
				"mouseover",
				function () { setBackOpacity(opacityFull); }
				)
			.on(
				"mouseout",
				function () { setBackOpacity(opacityHalf); }
				);
				
		$("#ctrl_back")
			.css("display", "block")
			.attr("title", title)
			.off("click")
			.on(
				"click",
				function () { bookViewer.openPreviousVisitedPage(); }
				);
	}
   
   this._canNotDownloadMessage[pageAtPortion] = "";
   if (pageContext.accessCode == "2")
   {
      var msg_title_download_link = "";
      if (pageContext.unlimited != "true")
      {
         var maxCount = parseInt(pageContext.maxCount, 10);
         var wasDownloadCount = parseInt(pageContext.wasDownloadCount, 10);
         if (maxCount > wasDownloadCount)
            msg_title_download_link = "Скачано " + wasDownloadCount + " страниц из " + maxCount + " доступных.";
         else
         {
            msg_title_download_link = "Скачивание недоступно. Исчерпано ограничение на количество скачанных страниц, уже скачано " + maxCount + " страниц.";
            this._canNotDownloadMessage[pageAtPortion] = msg_title_download_link;
         }
      }
      else
         msg_title_download_link = "Скачать страницу";
      
      var ctrl_downloadPage = pageAtPortion == 0 ? $("#ctrl_downloadPage") : $("#ctrl_downloadPage_2");
      ctrl_downloadPage
         .attr("title", msg_title_download_link)
         .css("cursor", this._canNotDownloadMessage[pageAtPortion] == "" ? "pointer" : "default");
   }
   else
   {
      var msg_title_download_link = "Скачивание недоступно";
      
      this._canNotDownloadMessage[pageAtPortion] = "Скачивание недоступно";
      
      var ctrl_downloadPage = pageAtPortion == 0 ? $("#ctrl_downloadPage") : $("#ctrl_downloadPage_2");
      ctrl_downloadPage
         .attr("title", msg_title_download_link);
   }
   
   this.isPageAtBookmark = [];
   for (var i = 0; i < this.pagePortionCount; i++)
   {
      this.isPageAtBookmark[i] = false;
      if (pageContext.bookmark_list != "")
      {
         var bookmark_list = pageContext.bookmark_list.split(",");
         for (var n in bookmark_list)
            if (this._currentPage + i == bookmark_list[n])
               this.isPageAtBookmark[i] = true;
      }
   }
   
   var ctrl_bookViewer_bookmarkButton = pageAtPortion == 0 ? $("#ctrl_bookViewer_bookmarkButton") : $("#ctrl_bookViewer_bookmarkButton_2");
   ctrl_bookViewer_bookmarkButton
      .attr("title", this.isPageAtBookmark[pageAtPortion] ? "Удалить закладку" : "Добавить закладку")
      .attr("src", this.isPageAtBookmark[pageAtPortion] ? HTTP_PATH + "/images/bookmark-f-.png" : HTTP_PATH + "/images/bookmark-f+.png");
   
   var bookmark_count = parseInt(pageContext.bookmark_count, 10);
   var max_bookmark_count = parseInt(pageContext.max_bookmark_count, 10);
   
   this.max_bookmark_count = max_bookmark_count;
   
   this.canAddBookmark = 
      function ()
      {
         if (bookmark_count < max_bookmark_count)
            return true;
         
         return false;
      };

   var noPageOption = $("#ctrl_bookViewer_sr [value='']");
   var currentPageOption = $("#ctrl_bookViewer_sr [value='" + this._currentPage + "']");
   if (currentPageOption.length > 0)
   {
      currentPageOption.prop("selected", true);
      if (noPageOption.length > 0)
         noPageOption.remove();
   }
   else
   {
      if (noPageOption.length == 0)
         $("#ctrl_bookViewer_sr").prepend($("<option value=''> </option>"));
      $("#ctrl_bookViewer_sr :first").prop("selected", true);
   }
   
   var pageViewer = this.pageViewer;
   var pageViewer_2 = undefined;
   if (this.pagePortionCount > 1)
      if (this._currentPage + 1 <= this._pageCount)
         pageViewer_2 = this.pageViewer_2;
   var afterRefreshOutlinesVisibility_action = 
      function ()
      {
         pageViewer.initializeScale();
         if (pageViewer_2 !== undefined)
            pageViewer_2.initializeScale();
      };
   this.outlineViewer.setOutlines(new Outlines(pageContext.outlines, pageContext.bookmark_comments_list, this.outlineViewer.getSettings(), this._currentPage));
   this.outlineViewer.set_afterRefreshOutlinesVisibility_action(afterRefreshOutlinesVisibility_action);
   this.outlineViewer.show();
   
   this.fld903 = pageContext.fld903;
}

BookViewer.prototype.showPage = function (textPageNumber)
{
   if (this.isUserCommandExecuting) return;
   
   var pageNumber = this.user_case_validatePageNumber(textPageNumber);
   
   if (isNaN(pageNumber))
   {
      this.showValidatorMessage();
      return;
   }
   
   this._showPage(pageNumber);
}

BookViewer.prototype._showPage = function (pageNumber, scrollingPosition, isComeBack)
{
   if (this.isUserCommandExecuting) return;
   
   if (!this.user_case_isValidDiapason(pageNumber)) return;
   
   if (!this._currentVisitController.isAvaliablePage(pageNumber))
   {
      alert("Просмотр недоступен. Исчерпано ограничение на количество просмотренных страниц, уже просмотрено " + this._currentVisitController.visitedPageCount() + " страниц.");
      return;
   }
   
	if (!isComeBack)
		if (this._currentPage !== undefined)
			this._visitedPageStack.push(this._currentPage);
	
   this._currentPage = pageNumber;
   
   this.showCurrentPage(scrollingPosition);
}

BookViewer.prototype.user_case_validatePageNumber = function (textPageNumber)
{
   textPageNumber = textPageNumber.trim();
   if (textPageNumber == "") return NaN;
   var pageNumber = parseInt(textPageNumber, 10);
   if (isNaN(pageNumber))
      showValidatorMessage();
   return pageNumber;
}

BookViewer.prototype.user_case_isValidDiapason = function (pageNumber)
{
   if ((pageNumber < 1) || (pageNumber > this._pageCount))
   {
      this.showValidatorMessage();
      return false;
   }
   return true;
}

BookViewer.prototype.showValidatorMessage = function ()
{
   alert("Укажите номер страницы от 1 до " + this._pageCount);
}

BookViewer.prototype.getNextPagePortion = function ()
{
	var nextPage = this._currentPage + this.pagePortionCount;
	return nextPage <= this._pageCount ? nextPage : this._currentPage;
}

BookViewer.prototype.getPrevPagePortion = function ()
{
	if (this._currentPage == 1) return 1;
	
	var previousPage = this._currentPage - this.pagePortionCount;
	if (previousPage < 1) previousPage = 1;
	return previousPage;
}

BookViewer.prototype.haveNextPagePortion = function ()
{
	return this.getNextPagePortion() != this._currentPage;
}

BookViewer.prototype.havePrevPagePortion = function ()
{
	return this.getPrevPagePortion() != this._currentPage;
}

BookViewer.prototype.showFirstPage = function ()
{
   this._showPage(1);
}

BookViewer.prototype.showLastPage = function ()
{
   this._showPage(this._pageCount);
}

BookViewer.prototype.showNextPagePortion = function ()
{
   this._showPage(this.getNextPagePortion());
}

BookViewer.prototype.showPrevPagePortion = function (scrollingPosition)
{
   this._showPage(this.getPrevPagePortion(), scrollingPosition);
}

BookViewer.prototype.downloadCurrentPage = function (pageAtPortion)
{
   if (this.isUserCommandExecuting) return;
   
   if (this._canNotDownloadMessage[pageAtPortion] != "")
   {
      alert(this._canNotDownloadMessage[pageAtPortion]);
      return;
   }
   
   this._canNotDownloadMessage[pageAtPortion] = "Вы уже скачали данную страницу.";
   var ctrl_downloadPage = pageAtPortion == 0 ? $("#ctrl_downloadPage") : $("#ctrl_downloadPage_2");
   ctrl_downloadPage
      .attr("title", this._canNotDownloadMessage[pageAtPortion])
      .css("cursor", "default");
   
	var page = this._currentPage + pageAtPortion;
	if (page > this._pageCount) page = this._pageCount;
   window.open(new WebIrbisQuery(CGI_PATH).createQuery_downloadPage(header_reader_rec, page));
}

BookViewer.prototype.bookmarkCurrentPage = function (note, pageAtPortion)
{
   var url = this.isPageAtBookmark[pageAtPortion] ? this._url_del_bookmark[pageAtPortion] : this._url_add_bookmark[pageAtPortion];
   
   if (!this.isPageAtBookmark[pageAtPortion])
      url = url + "&1_R21SUB1_2=A&1_R21VOL1_2=" + encodeURIComponent(note);
   
   if (this.isUserCommandExecuting) return;
   
   this.isUserCommandExecuting = true;
   
   var bookViewer = this;
   
   $.get(url,
      function (data)
      {
         bookViewer.isUserCommandExecuting = false;
         bookViewer.showCurrentPage("no-scroll");
      });
}

BookViewer.prototype.initPagePortionCount = function (pagePortionCount)
{
   this.pagePortionCount = pagePortionCount;
   
   this.setSecondPageBlankMode(this.pagePortionCount == 1);
   
   $("#photo_container_right_outer_2").css("display", this.pagePortionCount == 1 ? "none" : "block");
}

BookViewer.prototype.setPagePortionCount = function (pagePortionCount)
{
   this.initPagePortionCount(pagePortionCount);
   
   this.showCurrentPage("no-scroll");
}
