﻿function PageViewer(ui_container, ui_img, ui_scale, initialization_scale_value)
{
   this._ui_container = ui_container;
   this._ui_img = ui_img;
   this._ui_scale = ui_scale;
   this._initialization_scale_value = initialization_scale_value;
   
   this._image = new Image();
	
	this._is_deny_change_current_scale_value = false;
   
   this.current_scale_value = undefined;
}

PageViewer.prototype.showPageImage = function (pageNumber, updatePageControlParameters)
{
   var ui_img = this._ui_img;
   var pageViewer = this;
   var image = this._image;
   
   ui_img.attr("src", HTTP_PATH + "/images/loading2.gif");
	
	var pageViewer = this;
	var afterPageContextLoad =
		function (json_pageContext)
		{
			var pageContext = JSON.parse(json_pageContext);
			
			updatePageControlParameters(pageContext);
		};

   var afterPageImageLoad =
      function ()
      {
         pageViewer.initializeScale();
         
         var url = new WebIrbisQuery(CGI_PATH).createQuery_pageContext(header_reader_rec, pageNumber);
         $.ajax({
            url: url,
            success: afterPageContextLoad,
            error: function (XMLHttpRequest, textStatus, errorThrown) { alert("Error check access rights."); }
         });
      };
      
   var onload =
      function ()
      {
         ui_img.attr("src", image.src);
         
         afterPageImageLoad();
      };

   var onerror =
      function ()
      {
         ui_img.attr("src", HTTP_PATH + "/images/error.png");
         
         alert("Ошибка при загрузке страницы (возможно, шлюз не имеет полного доступа к файлу отображаемого документа)");
         
         afterPageImageLoad();
      };
   
   image.onload = onload;
   image.onerror = onerror;
   image.src = new WebIrbisQuery(CGI_PATH).createQuery_pageImage(header_reader_rec, pageNumber);
}

// Инициализировать состояние элемента управления масштабом и текущий масштаб.
// Данная инициализация необходима:
// 1) после загрузки изображения
// 2) после включения/выключения показа панели Содержание
PageViewer.prototype.initializeScale = function ()
{
   var value;
   var defaultScaleValue;
   var maxValue;
   var image = this._image;
   
   this._ui_container.css("width", "100%");
   this._ui_container.css("height", "auto");
   this._ui_img.css("width", "100%");
   this._ui_img.css("height", "auto");
   
   if (this._ui_img.width() < image.width)
      maxValue = 100;
   else
      maxValue = (this._ui_img.width() / image.width) * 100;
   
   defaultScaleValue = (this._ui_img.width() / image.width) * maxValue;
   
   if (this.current_scale_value == undefined)
      value = this._initialization_scale_value !== undefined ? this._initialization_scale_value : defaultScaleValue;
   else
      value = this.current_scale_value;
   
   this._ui_container.width(this._ui_img.width());
   
   this._ui_scale.slider("option", "max", maxValue);
	this._is_deny_change_current_scale_value = true;
   this._ui_scale.slider("value", value); // соответствующий обработчик на изменение значения не вызывается, поэтому нужно явно вызвать setScale
   this.setScale(value);
   this._is_deny_change_current_scale_value = false;
}

PageViewer.prototype.setScale = function (scale)
{
	this._scale = scale;
	
   var image = this._image;
   
	if (!this._is_deny_change_current_scale_value)
		this.current_scale_value = scale;
   
   this._ui_img.width(this.scaleValue(image.width));
   this._ui_img.height(this.scaleValue(image.height));

   this.scaleCenterOfRotation();
   
	this.scaleLinks();
}

PageViewer.prototype.scaleCenterOfRotation = function ()
{
   this._ui_img.removeProp("transform-origin");
   
   var has_rotated90 = this._ui_img.hasClass("rotated90");
   var has_rotated180 = this._ui_img.hasClass("rotated180");
   var has_rotated270 = this._ui_img.hasClass("rotated270");
   
   if (!has_rotated90 && !has_rotated180 && !has_rotated270) return;
   
   var coordinate_center_of_rotation;
   if (has_rotated90)
      coordinate_center_of_rotation = Math.floor(this._ui_img.height() / 2) + "px";
   if (has_rotated180)
      coordinate_center_of_rotation = "50%";
   if (has_rotated270)
      coordinate_center_of_rotation = Math.floor(this._ui_img.width() / 2) + "px";
      
	this._ui_img.css("transform-origin", coordinate_center_of_rotation + " " + coordinate_center_of_rotation);
}

PageViewer.prototype.scaleValue = function (value)
{
	return value * this._scale / 100;
}

PageViewer.prototype.setLinks = function (ui_link_lst, link_lst)
{
	this._ui_link_lst = ui_link_lst;
	this._link_lst = link_lst;
}

PageViewer.prototype.scaleLinks = function ()
{
	if (this._ui_link_lst !== undefined)
		for (var n in this._ui_link_lst)
		{
			this._ui_link_lst[n]
				.css("left", this.scaleValue(this._link_lst[n].left))
				.css("top", this.scaleValue(this._link_lst[n].top))
				.css("width", this.scaleValue(this._link_lst[n].width))
				.css("height", this.scaleValue(this._link_lst[n].height));
		}
}
