﻿function VisitController()
{
   this._visitedPages = new Object();
   
   this._active = false;
   this._maxVisitCount = 0;
}   

VisitController.prototype.activate = function (maxVisitCount)
{
   this._active = true;
   this._maxVisitCount = maxVisitCount;
}

VisitController.prototype.isVisitedPage = function (page)
{
   for (var visitedPage in this._visitedPages)
      if (visitedPage == page)
         return true;
   return false;
}

VisitController.prototype.isAvaliablePage = function (page)
{
   if (!this._active)
      return true;
      
   if (this.isVisitedPage(page))
      return true;
      
   if (this.rest() > 0)
      return true;
      
   return false;
}

VisitController.prototype.visitPage = function (page)
{
   if (this.isVisitedPage(page))
      return;
      
   this._visitedPages[page] = "";
}

VisitController.prototype.visitedPageCount = function ()
{
   return Object.keys(this._visitedPages).length;
}

VisitController.prototype.rest = function ()
{
   if (!this._active)
      return 1;
      
   return this._maxVisitCount - this.visitedPageCount();
}

