﻿var title_udc_navigator = "Поиск по классификатору УДК";
var title_lbc_navigator = "Поиск по классификатору ББК";

function WebIrbisSystem(cgiPATH)
{
   this._webIrbis = new WebIrbisQuery(cgiPATH);
   this._cgiPATH = cgiPATH;
}

WebIrbisSystem.prototype.applyWebIrbisSyntax = function (data)
{
   return data.split("<--HTTP_PATH-->").join(HTTP_PATH).split("<--CGI_PATH-->").join(CGI_PATH).split("~~").join("");
}

WebIrbisSystem.prototype.uc_saveQuery = function (user, queryName, queryPartFulltext, queryPartBibl, createDate, partialUpdateDate, fullUpdateDate, isUpdateMode)
{
   var webIrbis = this._webIrbis;
   webFunctionJSON(
      webIrbis.createQuery_QUERY_CONSTRUCTOR(header_rec, "account_context", "", "RDR_QUERY_CONSTRUCTOR"),
      function (accountContext)
      {
         var queryCount = parseInt(accountContext.queryCount, 10);
         var maxQueryCount = parseInt(accountContext.maxQueryCount, 10);
         if ((queryCount >= maxQueryCount) && !isUpdateMode)
         {
            alert("Запрос не был сохранён. Исчерпано ограничение на количество хранимых запросов.");
            return;
         }
         
         var url = webIrbis.createQuery_saveQuery(header_rec, accountContext, user, queryName, queryPartFulltext, queryPartBibl, createDate, partialUpdateDate, fullUpdateDate);
         
         executeAction(
            url,
            function()
            {
					if (!isUpdateMode)
						alert("Запрос сохранён.");
            },
            function(result)
            {
					if (!isUpdateMode)
						alert("Сохранение завершилось ошибкой. Возвращено значение '" + result + "'.");
            });
      });
}

WebIrbisSystem.prototype.uc_deleteStoredQuery = function (mfn, n, v2)
{
   var url = this._webIrbis.createQuery_deleteStoredQuery(header_rec, mfn, n, v2);
   
   executeAction(
      url,
      function()
      {
         refreshBrowserWindow();
      },
      function(result)
      {
         alert("~~Удаление завершилось ошибкой. Возвращено значение ~~'" + result + "'.");
      });
}

WebIrbisSystem.prototype.uc_executeQuery = function (ft_query, s21all_query)
{
   var url = this._webIrbis.createQuery_executeQuery(header_rec, ft_query, s21all_query);
   window.location = url;
}

WebIrbisSystem.prototype.uc_navigateUDC = function (lng, s21all)
{
	var url = this._webIrbis.createQuery_navigateUdc(header_rec, lng, s21all);
   browseURL(url, title_udc_navigator);
}

WebIrbisSystem.prototype.uc_searchUDC = function (lng, s21all, s21str, s21log, s21p01, s21stn)
{
   if (s21str.trim() == "")
      return;
   
   var url = this._webIrbis.createQuery_searchUDC(header_rec, lng, s21all, s21str, s21log, s21p01, s21stn);
   browseURL(url, title_udc_navigator);
}

WebIrbisSystem.prototype.uc_goPortionUDC = function (lng, s21all, s21stn)
{
   var url = this._webIrbis.createQuery_searchUDC(header_rec, lng, s21all, "", "", "", s21stn);
   
   browseURL(url, title_udc_navigator);
}

WebIrbisSystem.prototype.uc_createUrl_searchByUDC = function (lng, checkbox_elements)
{
   if (checkbox_elements.length == 0)
      return "";
   
   var udc_query_maker = function ()
      {
         var name = this.name;
         return name + "S21STR=" + encodeURIComponent(this.value) + "&" + name + "S21P02=1&" + name + "S21P03=U=&";
      };
      
   var udc_query = checkbox_elements.map(udc_query_maker).get().join("");
   var url = this._webIrbis.createQuery_search(header_rec, lng, "0", true);
   url = url + udc_query;
   return url;
}

WebIrbisSystem.prototype.uc_navigateLBC = function (lng, s21all)
{
   var url = this._webIrbis.createQuery_navigateLbc(header_rec, lng, s21all);
   browseURL(url, title_lbc_navigator);
}

WebIrbisSystem.prototype.uc_searchLBC = function (lng, s21all, s21str, s21log, s21p01, s21stn)
{
   if (s21str.trim() == "")
      return;
   
   var url = this._webIrbis.createQuery_searchLBC(header_rec, lng, s21all, s21str, s21log, s21p01, s21stn);
   browseURL(url, title_lbc_navigator);
}

WebIrbisSystem.prototype.uc_goPortionLBC = function (lng, s21all, s21stn)
{
   var url = this._webIrbis.createQuery_searchLBC(header_rec, lng, s21all, "", "", "", s21stn);
   
   browseURL(url, title_lbc_navigator);
}

WebIrbisSystem.prototype.uc_createUrl_searchByLBC = function (lng, checkbox_elements)
{
   if (checkbox_elements.length == 0)
      return "";
   
   var lbc_query_maker = function ()
      {
         var name = this.name;
         return name + "S21STR=" + encodeURIComponent(this.value) + "&" + name + "S21P02=1&" + name + "S21P03=U=&";
      };
      
   var lbc_query = checkbox_elements.map(lbc_query_maker).get().join("");
   var url = this._webIrbis.createQuery_search(header_rec, lng, "0", true);
   url = url + lbc_query;
   return url;
}

WebIrbisSystem.prototype.uc_createUrl_searchProfessional = function ()
{
	var search_field_list = sf_VAR_prof;
	
	for (var i in search_field_list)
		if (search_field_list[i] !== undefined)
		{
			search_field_list[i].fillS21STR();
			search_field_list[i].appendParams(this._webIrbis);
		}
	
	var logic = $("#variant_search_field_prof_logic").val();
	var url = this._webIrbis.createQuery_search(header_rec, "", logic, true);
	
	window.location = url;
}

WebIrbisSystem.prototype.uc_uploadText = function (form)
{
   if (checkOfDoubleClickForReloadCommand()) return;
   
   var formData = new FormData(form);
   browseURL(this._cgiPATH, "Результат запроса на загрузку текста", undefined, undefined, "POST", formData);
}

WebIrbisSystem.prototype.uc_printSearchResult = function (s21fmt, selection_type, sorting_type, max_count)
{
   var checked_controls = serializeCheckedControls();
   
   if ((selection_type == 2) && (checked_controls == ""))
   {
      alert("Отсутствуют отмеченные документы");
      return;
   }
   var url = this._webIrbis.createQuery_printSearchResult(header_rec, "_PRINT", s21fmt, selection_type, sorting_type, checked_controls, max_count);
   
   window.open(url);
}

WebIrbisSystem.prototype.uc_showCheckedBookLst = function (sorting_type, max_count)
{
   var checked_controls = serializeCheckedControls();
   
   orderLst_deleteCtrlName = new Array();
   orderLst_deleteUrl = new Array();
   
   if (checked_controls == "")
   {
      alert("Отсутствуют отмеченные документы");
      return;
   }
   var url = this._webIrbis.createQuery_printSearchResult(header_rec, "_FULLTEXT_SELECTED", "BriefHTML_ft", 2, sorting_type, checked_controls, max_count);
	
   browseURL(url, "Список отмеченных документов",
      function()
      {
         srrs_FULLTEXT_SELECTED.applyEachRecord(srShowResult_FULLTEXT_SELECTED);
      },
      function()
      {
         showCheckedControls();
      });
}

WebIrbisSystem.prototype.uc_openKO = function ()
{
   var url = this._webIrbis.createQuery_openTable(header_rec, "IBISLIST");
   
   window.open(url);
}

WebIrbisSystem.prototype.uc_openTableDolg = function ()
{
   var url = this._webIrbis.createQuery_openTable(header_rec, "RDRDOLG");
   
   window.open(url);
}

WebIrbisSystem.prototype.getSearchFieldList = function (hasBiblSearchField)
{
   var lst = [sf_NAME, sf_A1, sf_A34, sf_VAR];
   if (hasBiblSearchField || hasFulltextSwitchedToBiblSearch)
      lst.push(sf_VAR_biblSearchPriority);
   return lst;
}

WebIrbisSystem.prototype.goPortion = function (portionNumber)
{
	var url = this.getGoPortionUrl(portionNumber);
   
   window.location = url;
}

WebIrbisSystem.prototype.getGoPortionUrl = function (portionNumber)
{
   var s21all = this.getSearchFormS21all();
   
	var url = this._webIrbis.getURL_viewPortion(header_rec, new Object(), this.getSearchFieldList(), portionNumber, isExtendedSearchFieldsOn, isPersonalPanelOn, serializeCheckedControls(), side_search_panel_info, undefined, false, s21all);
   
   return url;
}

WebIrbisSystem.prototype.getSearchFormS21all = function ()
{
	return serializeS21all();
}

WebIrbisSystem.prototype.getStartDatabase = function (z21id, z21family, fn_initStartDatabese)
{
   var url = this._webIrbis.createQuery_startContext(header_rec, z21id, z21family);
   
   var fn_complete =
      function (context)
      {
         fn_initStartDatabese(context.dbn);
      };
   
   webFunctionJSON(
      url,
      fn_complete,
      "GET",
      false);
}

WebIrbisSystem.prototype.uc_updatePassword = function (header_rec, login, new_password, password_fld_tag, flagPASSWORDMD5)
{
   var webIrbisSystem = this;
   var webIrbis = this._webIrbis;
   
   var fn_on_get_current_user =
      function (context)
      {
         if (context.mfn == "")
         {
            alert("Ошибка: не найдена запись читателя.");
            return;
         }
         
         webIrbisSystem.updatePassword(
            header_rec,
            context.mfn,
            password_fld_tag,
            new_password,
            function()
            {
               alert("Пароль успешно обновлен");
            },
            function(result)
            {
               alert("Операция завершилось ошибкой. Возвращено значение '" + result + "'.");
            },
            flagPASSWORDMD5);
      };
   
   webFunctionJSON(
      webIrbis.createQuery_QUERY_CONSTRUCTOR(header_rec, "get_rdr_record", login),
      fn_on_get_current_user,
      "GET",
      false);
}

WebIrbisSystem.prototype.updatePassword = function (header_rec, mfn, password_fld_tag, new_password, fn_susess, fn_fail, flagPASSWORDMD5)
{
   if (flagPASSWORDMD5 == "1")
      new_password = MD5(unescape(encodeURIComponent(new_password))).toUpperCase();   
      
   executeAction(
      this._webIrbis.createQuery_updateFieldValue(header_rec, "RDR_QUERY_CONSTRUCTOR", "RDR_QUERY_CONSTRUCTOR", mfn, password_fld_tag, new_password),
      fn_susess,
      fn_fail);
}

WebIrbisSystem.prototype.getQrcode = function (value, ui)
{
   var webIrbis = this._webIrbis;
   
   ui.html("<img src='" + HTTP_PATH + "/images/loading2.gif' width='30' height='30'>");
   
   var fn_on_get_result =
      function (context)
      {
         if (context.qrcode != "")
         {
            ui.html(context.qrcode);
         }
      };
   
   setTimeout(
      function()
      {
         webFunctionJSON(
            webIrbis.createQuery_QUERY_CONSTRUCTOR(undefined, "get_qrcode", value),
            fn_on_get_result,
            "GET",
            false);
      },
      0);
}

WebIrbisSystem.prototype.tryBiblQuery = function (header_rec, fn_on_switching, DB_NAME)
{
   var s21all = this.getSearchFormS21all();
   
   var wi = this._webIrbis.getObject_viewPortion(header_rec,
      {
         "S21FMT" : "empty",
         "FT_S21LOG" : "",
         "FT_S21P01" : "",
         "FT_S21STR" : "",
         "SEARCH_STRING" : "",
         "DB_NAME" : DB_NAME
      },
      this.getSearchFieldList(true), 1, isExtendedSearchFieldsOn, isPersonalPanelOn, serializeCheckedControls(), side_search_panel_info, undefined, false, s21all, false);
   wi.appendParams_QUERY_CONSTRUCTOR(header_rec, "try_bibl_query", undefined);
   var url = wi.createURL();
   
   var fn_try_bibl_query =
      function (context)
      {
         var count = parseInt(context.v1001, 10);
         fn_on_switching(count);
      };
   
   webFunctionJSON(
      url,
      fn_try_bibl_query,
      "GET",
      false);
}

WebIrbisSystem.prototype.getRecommendations = function (header_rec, value, ui)
{
   var webIrbis = this._webIrbis;
   var webIrbisSystem = this;
   
   var fn_on_get_result =
      function (context)
      {
         if (context.html != "")
         {
            ui.html(webIrbisSystem.applyWebIrbisSyntax(context.html));
         }
         else
         {
            ui.html("<br/>Отсутствуют рекомендации<br/>");
         }
      };
   
   webFunctionJSON(
      webIrbis.createQuery_QUERY_CONSTRUCTOR(header_rec, "get_recommendations", value),
      fn_on_get_result,
      "GET",
      false);
}

WebIrbisSystem.prototype.restorePassword = function (login, email, password_fld_tag, flagPASSWORDMD5, fn_on_complete)
{
   if (login == "")
   {
      alert("Логин не может быть пустым.");
      return;
   }
   if (email == "")
   {
      alert("Адрес электронной почты не может быть пустым.");
      return;
   }
   
   var webIrbisSystem = this;
   var webIrbis = this._webIrbis;
   
   var fn_on_get_current_user =
      function (context)
      {
         if (context.mfn == "")
         {
            alert("Указанный логин отсутствует в базе читателей.");
            return;
         }
         if (context.email == "")
         {
            alert("Восстановление пароля невозможно - в личном кабинете отсутствует адрес электронной почты.");
            return;
         }
         if (context.email != email)
         {
            alert("Адрес электронной почты не соответствует указанному в личном кабинете.");
            return;
         }
         
         var new_password = Math.random().toString().substring(2, 7);
         webIrbisSystem.updatePassword(
            undefined,
            context.mfn,
            password_fld_tag,
            new_password,
            function()
            {
               executeAction(
                  webIrbis.createQuery_QUERY_CONSTRUCTOR(undefined, "restore_password_send_email", [login, new_password]),
                  function()
                  {
                     alert("Новый пароль отправлен на ваш email");
                     
                     setTimeout(fn_on_complete, 0);
                  },
                  function(result)
                  {
                     alert("Операция отправки нового пароля завершилась ошибкой. Возвращено значение '" + result + "'.");
                  });
            },
            function(result)
            {
               alert("Операция присвоения нового пароля завершилась ошибкой. Возвращено значение '" + result + "'.");
            },
            flagPASSWORDMD5);
      };
   
   webFunctionJSON(
      webIrbis.createQuery_QUERY_CONSTRUCTOR(undefined, "get_rdr_record", login),
      fn_on_get_current_user,
      "GET",
      false);
}

WebIrbisSystem.prototype.logInByLdap = function (login, password, logInAs)
{
   var webIrbis = this._webIrbis;
   
   var fn_complete_ldap_authentication =
      function (context)
      {
         var ldap_object = context;
         var samaccountname = context.samaccountname;
         
         if (samaccountname != login)
         {
            alert("Ошибка входа через LDAP. Возможно, неверно указан логин и/или пароль. Подробности ошибки: " + context.extended_error);
            return;
         }
         
         var fn_complete_user_check =
            function (context)
            {
               var logIn = function () { logInAs(samaccountname, ""); };
               if (context.mfn == "")
               {
                  var result = confirm("Вы первый раз входите в Веб-ИРБИС через LDAP, при этом в ИРБИС будет создана учётная запись в соответствии с данными, полученными через LDAP. Подтверждаете данное действие?");
                  if (result)
                  {
                     var url = webIrbis.createQuery_addRdrRecord(samaccountname, ldap_object);
                     webFunctionJSON(
                        url,
                        logIn,
                        "GET",
                        false);
                  }
                  else
                  {
                     return;
                  }
               }
               else
               {
                  logIn();
               }
            };
         
         webFunctionJSON(
            webIrbis.createQuery_QUERY_CONSTRUCTOR(undefined, "get_rdr_record", samaccountname),
            fn_complete_user_check,
            "GET",
            false);
      };
   
   var url = webIrbis.getURL_logInByLdap(login, password);
   webFunctionJSON(
      url,
      fn_complete_ldap_authentication,
      "GET",
      false);
}

WebIrbisSystem.prototype.goPortionAtDatabase = function (DB_NAME)
{
   var s21all = this.getSearchFormS21all();
   
	var url = this._webIrbis.getURL_viewPortion(header_rec,
		{
			"DB_NAME" : DB_NAME
		},
		this.getSearchFieldList(), 1, isExtendedSearchFieldsOn, isPersonalPanelOn, serializeCheckedControls(), side_search_panel_info, undefined, false, s21all);
   
   window.location = url;
}

WebIrbisSystem.prototype.goPortionSorted = function (s21srw, s21srd)
{
   var s21all = this.getSearchFormS21all();
   
	var url = this._webIrbis.getURL_viewPortion(header_rec,
		{
			"S21SRW" : s21srw,
			"S21SRD" : s21srd
		},
		this.getSearchFieldList(), 1, isExtendedSearchFieldsOn, isPersonalPanelOn, serializeCheckedControls(), side_search_panel_info, undefined, false, s21all);
   
   window.location = url;
}

WebIrbisSystem.prototype.initializeSideSearchPanel = function (ui_side_search_panel_header, ui_side_search_panel, rec)
{
   applyBiblSearchLogic();
   var s21all = this.getSearchFormS21all();
   
   side_search_panel_info = header_rec.getIrbisField_First("side_search_panel_info");
   
   var count_array = [];
   if (side_search_panel_info != "")
   {
      count_array = side_search_panel_info.split(";");
      count_array.pop();
   }
   
   var sideSourceLst = [];
   var settings_array = rec.getIrbisField_Array("settings");
   var name_array = rec.getIrbisField_Array("name");
   var isValidCountLst = (count_array.length == name_array.length);
   for (var i = 0; i < name_array.length; i++)
   {
      var source = new Object();
      source.name = name_array[i];
      var settings = JSON.parse(settings_array[i]);
      source.url_service = new WebIrbisQuery(settings.url).getURL_search_service(header_rec, this.getSearchFieldList(), isExtendedSearchFieldsOn, isPersonalPanelOn, serializeCheckedControls());
      source.url_GUI = new WebIrbisQuery(settings.url).getURL_viewPortion(header_rec, new Object(), this.getSearchFieldList(), 1, isExtendedSearchFieldsOn, isPersonalPanelOn, serializeCheckedControls(), undefined, settings.login, false, s21all);
      if (isValidCountLst)
         if (count_array[i] !== undefined)
         {
            source.info = new Object();
            source.info.count = count_array[i];
         }
      sideSourceLst.push(source);
   }
   
   var sideSearchPanel = new SideSearchPanel(
      ui_side_search_panel_header, 
      ui_side_search_panel, 
      sideSourceLst, 
      function() 
      {
         side_search_panel_info = sideSearchPanel.serializeCountLst();
      });
      
   sideSearchPanel.show();
}

WebIrbisSystem.prototype.openUserLiteratureList = function (header_rec)
{
   var webIrbis = this._webIrbis;
   
   setTimeout(
      function()
      {
         var url = webIrbis.createQuery_userLiteratureList(header_rec);
         
         browseURL(url, "Литература на руках");
      },
      0);
}

WebIrbisSystem.prototype.prolongLiterature = function (header_rec)
{
   if (!confirm("Продлить издания?")) return;
   
   var url = CGI_PATH + "?" + $("#ctrl_prodlenie_form").serialize();
   executeAction(
      url,
      function()
      {
         new WebIrbisSystem(CGI_PATH).openUserLiteratureList(header_rec);
      },
      function(msg)
      {
         alert(msg);
      },
      "POST");
}
